const _Http = getApp().globalData.http;
Component({
    options: {
        addGlobalClass: true
    },
    properties: {
        list: Array,
        changeTotal: Function,
        disabled: Boolean
    },
    data: {
        radio: 0, //默认
    },
    methods: {
        // 修改默认
        radioChange({
            detail
        }) {
            let list = this.data.list,
                data = list.find(v => v.contactsid == detail)
            _Http.basic({
                "id": "20221018144702",
                "content": {
                    "contactsid": data.contactsid,
                    "sys_enterpriseid": data.sys_enterpriseid
                }
            }, false).then(res => {
                if (res.msg != '成功') return wx.showToast({
                    title: res.data,
                    icon: "none"
                });

                getCurrentPages().forEach(v => {
                    //更新列表
                    if (["packageA/setclient/detail", "packageA/setclient/modules/contacts/detail/index"].includes(v.__route__)) {
                        let page = v.selectComponent("#Address").selectComponent("#List");
                        const lists = page.data.list.map(value => {
                            value.isdefault = value.contactsid == data.contactsid ? 1 : 0
                            return value
                        });
                        page.setData({
                            list: lists
                        })
                        setTimeout(() => {
                            page.initRadio();
                        }, 200)
                    };
                    if (["packageA/setclient/modules/address/search/index"].includes(v.__route__)) {
                        let page = v.selectComponent("#List");
                        const lists = page.data.list.map(value => {
                            value.isdefault = value.contactsid == data.contactsid ? 1 : 0
                            return value
                        });
                        page.setData({
                            list: lists
                        })
                        setTimeout(() => {
                            page.initRadio();
                        }, 200)
                    };
                })
            })
        }, //处理操作
        handleItem(e) {
            const {
                name,
                item
            } = e.target.dataset,
                that = this;
            if (!name) return;
            switch (name) {
                case 'call':
                    wx.makePhoneCall({
                        phoneNumber: item.phonenumber,
                    })
                    break;
                case 'copy':
                    let str = `联系人：${item.name}\n手机号码：${item.phonenumber}\n所在地区：${item.province+item.city+item.county}\n详细地址：${item.province+item.city+item.county+item.address}`
                    wx.setClipboardData({
                        data: str,
                    })
                    break;
                case 'edit':
                    wx.navigateTo({
                        url: '/packageA/setclient/modules/address/add/index?data=' + JSON.stringify(item),
                    })
                    break;
                case 'delete':
                    wx.showModal({
                        title: '提示',
                        content: `是否确认删除"${item.name}"`,
                        complete: (res) => {
                            if (res.confirm) {
                                _Http.basic({
                                    "id": "20221018145502",
                                    "content": {
                                        "contactsid": item.contactsid,
                                        "sys_enterpriseid": item.sys_enterpriseid
                                    }
                                }).then(res => {
                                    console.log("删除地址", res)
                                    if (res.msg != '成功') return wx.showToast({
                                        title: res.data,
                                        icon: "none"
                                    });
                                    wx.showToast({
                                        title: `删除成功！`,
                                        icon: "none"
                                    });
                                    getCurrentPages().forEach(v => {
                                        if (v.__route__ == "packageA/setclient/detail" || v.__route__ == "packageA/opponent/detail" || v.__route__ == "packageA/publicCustomer/detail") {
                                            let model = v.selectComponent("#Address");
                                            model.setData({
                                                list: model.data.list.filter(value => value.contactsid != item.contactsid)
                                            });
                                            model.changeTotal();
                                        } else if (v.__route__ == "packageA/setclient/modules/address/search/index") {
                                            v.setData({
                                                list: v.data.list.filter(value => value.contactsid != item.contactsid)
                                            });
                                        }
                                    })
                                })
                            }
                        }
                    })
                    break;
            }
        },
        initRadio() {
            let data = this.data.list.find(v => v.isdefault == 1);
            this.setData({
                radio: data ? data.contactsid : 0
            })
        },
    }
})